function [im,sil]=extractSil(num,sz,dirname,template,templateSil,prep)
% im=extractSil(num,sz,dirname,template,templateSil,prep)
% - read the image and the silhouette
% - find BB
% - pad it to make the right size
% - return image and silhouette

if (nargin < 3)
  dirname='.';
end
  
if (nargin < 4 | length(template)==0)
  template='st%05d_R.jpg';
end
if (nargin < 5 | length(templateSil)==0)
  templateSil='st%05d_R_sil.jpg';
end

im=imread([dirname '/' sprintf(template,num)]);
if (size(im,3)>1) im=rgb2gray(im); end
sil=imread([dirname '/' sprintf(templateSil,num)]);
if (size(sil,3)>1) sil=rgb2gray(sil); end
if (max(sil(:))==255)
  sil(find(sil <200))=0;
  sil(find(sil))=1;
else
  sil(find(sil>0))=1;
end

if (nargin >= 6 & ~isempty(prep) & ~strcmp(prep,''))
  switch prep,
   case {'prep1','prep2'},
    sil=feval(prep,sil);
   otherwise,
    error(['Unknown prep function: ' prep]);
  end
end
%figure;imagesc(sil);
box=findBB(sil);
sil=double(imresize(padBB(sil,box),[sz sz],'nearest'));


im=double(imresize(padBB(im,box),[sz sz],'bicubic')); %.*sil;


function extIm=padBB(im,bb)
extIm=zeros(bb.size,bb.size);
extIm(1:bb.padRowT,:)=0;
extIm(:,1:bb.padColL)=0;
extIm(bb.padRowB+1:end,:)=0;
extIm(:,bb.padColR+1:end)=0;
r1=bb.padRowT+1; r2=bb.padRowT+bb.imRows;
c1=bb.padColL+1; c2=bb.padColL+bb.imCols;
extIm(r1:r2,c1:c2)=im(bb.startRow:bb.endRow,bb.startCol:bb.endCol);
