function ii = iimage(im,how)
% II = IIMAGE(IM,'i') (default)
%
%   Constructs integral image of graylevel IM (converted to graylevel if
%   necessary). II(i,j) is the sum of pixels in IM(1:i-1,1:j-1)
%   this means that II(1,:) = II(:,1) = 0, by definition, anf that the
%   dimensions of II are one larger than those of IM.
%
% II = IIMAGE(IM,'rgb')
% 
% returns in II(:,1) the int. image of the red component, in II(:,2) of
% the green and in II(:,3) of the blue. 

if (nargin < 2)
  how = 'i';
end


if (size(im,3)==3 & strcmp(how,'i'))
  im=rgb2gray(im);
end

if (strcmp(how,'i'))
  K = 1;
else
  K = 3;
end

sz = size(im); sz(1)=sz(1)+1;sz(2)=sz(2)+1;

ii=zeros(sz);

ii(:,1,:)=0;
ii(1,:,:)=0;

for j=1:K
  for r=2:size(im,1)+1
    ii(r,2:end,j)=cumsum(double(im(r-1,:,j)))+ii(r-1,2:end,j);
  end
end
