# renderDB.py
#
# This script generates a DB of pose-labeled images

# (C) Greg Shakhnarovich, TTI-Chicago, 2007

import poser
import sys
sys.path = sys.path + ['c:\\greg\\Poser\\py']

startDir=49; # will start from this directory
lastDir = 57; # and end with this one
imPerDir = 30000; # how many images (poses) per directory

from runPoseSeq import *
# doStereo = true means we do both R and L image
poseSeqOpt['doStereo']=True
# drop=True means feet touch floor
poseSeqOpt['drop']=True
# probability of changing clothes
poseSeqOpt['probClothesChange']=.01;
# constraints on yaw of the body
poseSeqOpt['orient']=[-120,120];
# varyZ and varyY: translation constraints
poseSeqOpt['varyZ']=[-.2*.38,.2*.38];
poseSeqOpt['varyX']=[-.2*.38,.2*.38];
# nuisance=True means vary nuisance params. randomly
poseSeqOpt['nuisance']=True;
# specs of angle I/O
poseSeqOpt['paramfile']="C:\\greg\\Poser\\paramList.txt"
# how many images for each pose (random viewpoints)
poseSeqOpt['times']=3;

# make sure to run the following before callling renderDB:
# * setcam - set up the current camera
# * fixnames - a hack to fix a bug in Poser
# * manually load a clothing item and hair (again, a bug workaround)
# * export an image with the right JPEG settings (---- " ----)

# the range here runs through directory indices. This particular set of values:
#  startDir=3
#  lastDir=7
#  imPerDir = 30000
# will create 5 directories: data0003,data0004,...,data0007
# with images numbered 60001..90000 in data0003, etc.
for x in range (startDir,lastDir):
    poseSeqOpt['start']=imPerDir*(x-1)+1;
    # where you want the images to go
    poseSeqOpt['outDir']="c:\\Poser\\data%04d\\" % x
    poseSeqOpt['saveXYZ']="XYZ%04d.txt" % x
    poseSeqOpt['saveAngles']="Angles%04d.txt" % x
    #angles="x:\\greg\\pose\\bvh\\usedAngles%03d.txt" % x
    # the file with pose params.
    angles="c:\\Poser\\BVH\\poses\\usedAngles%03d.txt" % x
    # the next line actually runs through a sequence of poses and generates
    # the images
    runPoseSeq(angles,'ex%08d');
    
    


